""" Generator functions related to trial and test functions and the accumulation loop"""

from dune.perftool.pdelab import dune_symbol, dune_preamble
from dune.perftool.ufl.modified_terminals import ModifiedArgumentDescriptor

@dune_symbol
def name_testfunction(modarg):
    ma = ModifiedArgumentDescriptor(modarg)
    if len(ma.expr.element().sub_elements()) > 0:
        pass
    return "{}a{}".format("grad_" if ma.grad else "", ma.expr.number())

@dune_symbol
def name_trialfunction(modarg):
    ma = ModifiedArgumentDescriptor(modarg)
    return "{}c{}".format("grad_" if ma.grad else "", ma.expr.count())

@dune_symbol
def name_testfunctionspace(*a):
    #TODO
    return "lfsv"

@dune_symbol
def name_trialfunctionspace(*a):
    #TODO
    return "lfsu"

def name_argumentspace(modarg):
    ma = ModifiedArgumentDescriptor(modarg)
    if ma.expr.number() == 0:
        return name_testfunctionspace(modarg)
    if ma.expr.number() == 1:
        return name_trialfunctionspace(modarg)
    # We should never encounter an argument other than 0 or 1
    assert False


def name_argument(modarg):
    ma = ModifiedArgumentDescriptor(modarg)
    if ma.expr.number() == 0:
        return name_testfunction(modarg)
    if ma.expr.number() == 1:
        return name_trialfunction(modarg)
    # We should never encounter an argument other than 0 or 1
    assert False

@dune_symbol
def name_residual():
    return "r"
